#include <conio.h>

/*
	256 x 240 pixels (256 x 224)
	 32 x  30 chars  ( 32 x  28)
*/

#define JOYPAD     (char*)0x4016

#define BTN_A      0x80
#define BTN_B      0x40
#define BTN_SELECT 0x20
#define BTN_START  0x10
#define BTN_UP     0x08
#define BTN_DOWN   0x04
#define BTN_LEFT   0x02
#define BTN_RIGHT  0x01

enum {
	BTN_STAT_PRESS = 0,
	BTN_STAT_DOWN,
	BTN_STAT_UP,
	BTN_STAT_MAX
};

#define PLAYER_MAX 2

unsigned char padinfo[PLAYER_MAX][BTN_STAT_MAX];

//player:0=1P , 1=2P
void read_pad(unsigned char player)
{
	unsigned char i;
	unsigned char p;
	unsigned char c;

	*JOYPAD = 1;
	*JOYPAD = 0;

	p = padinfo[player][BTN_STAT_PRESS];
	c = 0;

	for(i = 0; i < 8; i++) {
		c <<= 1;
		c |= (*(JOYPAD + player) & 0x01);
	}

	padinfo[player][BTN_STAT_PRESS] =  c;
	padinfo[player][BTN_STAT_DOWN ] =  c & ~p;
	padinfo[player][BTN_STAT_UP   ] = ~c &  p;
}

//{^ςȂ
#define is_btn_press(player,btn) \
	(padinfo[player][BTN_STAT_PRESS] & btn)

//{^
#define is_btn_down(player,btn) \
	(padinfo[player][BTN_STAT_DOWN] & btn)

//{^𗣂
#define is_btn_up(player,btn) \
	(padinfo[player][BTN_STAT_UP] & btn)

void main(void)
{
	clrscr();

	cprintf("CHECK START\r\n");

	while(1)
	{
		read_pad(0);

		if (is_btn_down(0, BTN_A)) {
			cprintf("A");
		}
		if (is_btn_down(0, BTN_B) ) {
			cprintf("B");
		}
		if ( is_btn_up(0, BTN_SELECT)) {
			cprintf("s");
		}
		if ( is_btn_up(0, BTN_START)) {
			cprintf("S");
		}
		if ( is_btn_press(0, BTN_UP)) {
			cprintf("U");
		}
		if ( is_btn_press(0, BTN_DOWN)) {
			cprintf("D");
		}
		if ( is_btn_press(0, BTN_LEFT)) {
			cprintf("L");
		}
		if ( is_btn_press(0, BTN_RIGHT)) {
			cprintf("R");
		}

		if (wherey() > 27) {
			clrscr();
			gotoxy(0, 0);
		}
	}
}
