;----------------------------------------------------------------------------
;				NES Startup
;					Copyright (C) 2007, Tekepen
;					Arranged By 2014, @MIRROR_
;----------------------------------------------------------------------------
.setcpu		"6502"
.autoimport	on
.importzp	sp

.global	_NesMain

; iNESwb_
.segment "HEADER"
	.byte	$4E, $45, $53, $1A	; "NES" Header
	.byte	$02			; PRG-BANKS 16K x 2
	.byte	$01			; CHR-BANKS  8k x 1
	.byte	$00			; 0:Horizontal/1:Vertical/3:Vertical & WRAM Mirror
	.byte	$00			; 
	.byte	$00, $00, $00, $00	; 
	.byte	$00, $00, $00, $00	; 

.segment "STARTUP"
; Zbg荞
.proc	Reset
	sei
	ldx	#$ff
	txs
	
	; \tgEFAX^bNݒ
	lda	#$ff
	sta	sp
	lda	#$03
	sta	sp + 1
	
	; C֐Ăяo
	jsr	_NesMain
.endproc

; VBlank荞
.proc	NMI
	; WX^ޔ
	pha
	txa
	pha
	tya
	pha

	; ֐Ăяo
	jsr	_NMIProc

	; WX^A
	pla
	tay
	pla
	tax
	pla
	rti
.endproc

; xN^e[u
.segment "VECTORS"
	.word	NMI
	.word	Reset
	.word	$0000
