#include "nes.h"
#include "map.h"

// C
void NesMain()
{
	unsigned char frame = 0;
	unsigned char scene = 0;

	// PPȔ
	InitPPU();

	// DMA
	InitDMA();

	// BG]R}ḧ揉
	InitCMD();

	// }bv
	map_init(scene);

	// wi̕\ʒuݒ
	SetScroll(0, 0);

	// `Jn(NMI荞ݗL)
	SetPPU(0x88, 0x1e);

	while (1) {
		// ݏI҂
		Sync();

		// BG]R}h
		ResetCMD();

		//Rg[mF
		CheckPad();

		if (ButtonDown(0, BTN_A)) {
			scene = (scene + 1) % 5;

			// PPȔ
			InitPPU();

			// }bv
			map_init(scene);

			// wi̕\ʒuݒ
			SetScroll(0, 0);

			// `Jn(NMI荞ݗL)
			SetPPU(0x88, 0x1e);
		}

		// TODO : Q[C̏

		// BG]f[^ݒI
		SetEndCMD();

		// t[JE^XV
		++frame;
	}
}

// NMI荞
void NMIProc(void)
{
	// ҂JnmF
	if (CheckSync()) {

		// BG]R}hs
		SendCMD();

		// XN[l̍Đݒ
		ResetScroll();

		// ݒ
		DoneSync();
	}
}
