// nes.c
//
// cc65@wikiɌfڂkihon.h̓eɗ̓}No[WC\[X
#include "nes.h"

volatile unsigned char sync;

unsigned char padinfo[PLAYER_MAX][BTN_STAT_MAX];
unsigned char padother;

unsigned char dma_cnt;

unsigned char cmd_cnt;
unsigned int  screen_adr;

unsigned char scroll_x, scroll_y;

const unsigned int screens[SCREEN_MAX] = {0x2000, 0x2800, 0x2400, 0x2c00};

void SetNameTbl(const unsigned char *tbl, char x, char y, char w, char h) {
	char i, j;

	for (j = 0; j < h; ++j) {
		SetBackgroundAddress(x, y + j);

		for (i = 0; i < w; ++i) {
			*REGIST_GRA = *tbl++;
		}
	}
}

void SetCprNameTbl(const unsigned char *tbl, char x, char y, char w, char h, unsigned char ofs) {
	unsigned char ch;
	char cnt;
	char i, j;

	ch  = 0;
	cnt = 0;

	for (j = 0; j < h; ++j) {
		SetBackgroundAddress(x, y + j);

		for (i = 0; i < w; ++i) {
			if (cnt > 0) {
				--cnt;
			} else {
				ch  = *tbl++;
				cnt = (ch >> 6) & 3;
				ch  = (ch & 0x3f) + ofs;
			}

			*REGIST_GRA = ch;
		}
	}
}

void FillNameTbl(char x, char y, char w, char h, unsigned char ch) {
	char i, j;

	for (j = 0; j < h; ++j) {
		SetBackgroundAddress(x, y + j);

		for (i = 0; i < w; ++i) {
			*REGIST_GRA = ch;
		}
	}
}
