#ifndef CHARA_H_INCLUDED
#define CHARA_H_INCLUDED

// LN^ID
enum {
	CHR_BLUE_PENGUIN = 0,
	CHR_RED_PENGUIN,
	CHR_PLAYERS = CHR_RED_PENGUIN,
	CHR_SLIME,
	CHR_WIZARD,
	CHR_FIRE_BALL,
	CHR_MAX,
	CHR_NOTHING = 0xff
};

// LN^
typedef struct Chara {
	unsigned char chr;    // LN^ԍ
	unsigned char status; // 
	unsigned char dir;    // 
	unsigned char x, y;   // ʒu
	char dx, dy;          // 
} Chara;

// {[
typedef struct Ball {
	unsigned char status;
	unsigned char x;
	unsigned char y;
	unsigned char dir;
} Ball;

extern void chara_init(Chara* chara, unsigned char cnt);
extern void chara_draw(Chara* chara, unsigned char cnt, unsigned char frame);

#endif
