#ifndef CHARA_H_INCLUDED
#define CHARA_H_INCLUDED

#define STATUS_BUSY 0x80
#define STATUS_GOAL 0x40

#define CHARA_MAX 10
#define CHARA_P1   0
#define CHARA_P2   1
#define CHARA_ENEMY_TOP 2
#define CHARA_ENEMY_BTM 8

#define FIRE_BALL_TOP  8

// LN^ID
enum {
	CHR_BLUE_PENGUIN = 0,
	CHR_RED_PENGUIN,
	CHR_PLAYERS = CHR_RED_PENGUIN,
	CHR_SLIME,
	CHR_WIZARD,
	CHR_FIRE_BALL,
	CHR_MAX,
	CHR_NOTHING = 0xff
};

// LN^
typedef struct Chara {
	unsigned char id;     // }bvID
	unsigned char chr;    // LN^ԍ
	unsigned char status; // 
	unsigned char dir;    // 
	unsigned char x, y;   // ʒu
	char dx, dy;          // 
} Chara;

// {[
typedef struct Ball {
	unsigned char status;
	unsigned char x;
	unsigned char y;
	unsigned char dir;
} Ball;

extern Chara chara[CHARA_MAX];
extern Ball ball;

extern void __fastcall__ chara_init(void);
extern void __fastcall__ chara_draw(unsigned char frame);

extern unsigned char __fastcall__  action_slime(Chara* b);
extern unsigned char __fastcall__  action_wizard(Chara* b);
extern unsigned char __fastcall__  action_fireball(Chara* b);

#endif
