#ifndef MAP_H_INCLUDED
#define MAP_H_INCLUDED

#define BG_NAMTBL_W (SCREEN_W/8)
#define BG_NAMTBL_H (SCREEN_H/8)
#define BG_ATTR_W   8
#define BG_ATTR_H   8

#define BG_FIELD_W  (BG_NAMTBL_W/2)
#define BG_FIELD_H  (BG_NAMTBL_H/2)
#define MAP_FIELD_W 12
#define MAP_FIELD_H 11

#define MAP_SYNBOL(chr, mcp) (((chr+1) << 4)|(mcp))
#define GET_CHAR_ID(m)       ((((m) >> 4)-1) & 0x0f)
#define GET_CHIP_ID(m)       ((m) & 0x0f)

#define MAP_SYMBOL_CHR(chr)  ((chr+1) << 4)
#define GET_SYMBOL_CHR(m)    ((m) & 0xf0)

// }bv`bvID
enum {
	MCP_FIELD = 0,
	MCP_BALL,
	MCP_GOAL,
	MCP_WALL,
	MCP_BLOCK,
	MCP_FBLOCK,
	MCP_MAX
};

extern void map_init(char scene, Chara* chara, unsigned char cnt);
extern char map_getmcp(unsigned char x, unsigned char y);

#endif
