#include "nes.h"
#include "map.h"

// XvCgppbg
const char palettesp[] = {
	0x30, 0x26, 0x30, 0x01,
	0x2c, 0x16, 0x30, 0x25,
	0x0f, 0x00, 0x30, 0x10,
	0x0f, 0x00, 0x30, 0x10,
};

// C
void NesMain()
{
	unsigned char frame = 0;
	unsigned char scene = 0;

	unsigned char x = 50, y = 50;

	// PPȔ
	InitPPU();

	// DMA
	InitDMA();

	// BG]R}ḧ揉
	InitCMD();

	// }bv
	map_init(scene);

	// pbgݒ
	SetPalette(palettesp, 1);

	// wi̕\ʒuݒ
	SetScroll(0, 0);

	// `Jn(NMI荞ݗL)
	SetPPU(0x88, 0x1e);

	while (1) {
		// ݏI҂
		Sync();

		// BG]R}h
		ResetCMD();

		// DMA]\񏉊
		ResetDMA();

		// Rg[mF
		CheckPad();

		// XvCg̕\ʒuύX
		if ( ButtonPress(0, BTN_UP   ) ) { y--; }
		if ( ButtonPress(0, BTN_DOWN ) ) { y++; }
		if ( ButtonPress(0, BTN_LEFT ) ) { x--; }
		if ( ButtonPress(0, BTN_RIGHT) ) { x++; }

		SetDMA(x-8, y-12, 0x01, 0);
		SetDMA(x  , y-12, 0x02, 0);
		SetDMA(x-8, y- 4, 0x1f, 0);
		SetDMA(x  , y- 4, 0x20, 0);

		// BG]f[^ݒI
		SetEndCMD();

		// t[JE^XV
		++frame;
	}
}

// NMI荞
void NMIProc(void)
{
	// ҂JnmF
	if (CheckSync()) {

		// DMA]
		SendDMA();

		// BG]R}hs
		SendCMD();

		// XN[l̍Đݒ
		ResetScroll();

		// ݒ
		DoneSync();
	}
}
