#ifndef MATH_H_INCLUDED
#define MATH_H_INCLUDED

/*
 * CfbNXQƂ̎Op֐
 * 0`2560`2΂\B
 */
extern const char costbl[];
#define cos(rad) costbl[(unsigned char)rad]
#define sin(rad) costbl[(unsigned char)((rad-64) & 0xff)]

/*
 * 16777215(=2^24-1)̗
 *
 * 8bitpxorshiftASY
 * <http://blog.goo.ne.jp/sim00/e/33b576696be51efbb3eab4b5c61ffb87>
 */
extern unsigned char rand_x, rand_y, rand_z;
#define srand(seed0, seed1, seed2) rand_x = seed0, rand_y = seed1, rand_z = seed2
#define rand(t) \
	t = rand_x ^ rand_x << 1; \
	rand_x = rand_y; \
	rand_y = rand_z; \
	rand_z ^= rand_z >> 3 ^ t ^ t >> 5; \
	t = rand_z;

/*
 * ł̌̕vZ
 *
 * lZ̃ASY
 * <www001.upp.so-net.ne.jp/y_yutaka/labo/math_algo/math_algo.html>
 */
#define sqrt(y, x) \
	if (x <= 0) y = 0; \
	else { \
		int s = 1; \
		y = x; \
		while (s < y) {s <<= 1; y >>= 1;} \
		do { \
			y = s; \
			s = (x / s + s) >> 1; \
		} while (s < y); \
	}

#endif
